## mongrel2 1.9.1

=== Makefile ===
CFLAGS=-g -O2 -Wall -Wextra -Isrc -Isrc/polarssl/include -pthread -rdynamic -DNDEBUG $(OPTFLAGS) -D_FILE_OFFSET_BITS=64
LIBS=-lzmq -ldl -lsqlite3 $(OPTLIBS)
PREFIX?=/usr/local

get_objs = $(addsuffix .o,$(basename $(wildcard $(1))))

ASM=$(wildcard src/**/*.S src/*.S)
RAGEL_TARGETS=src/state.c src/http11/http11_parser.c
SOURCES=$(wildcard src/polarssl/library/*.c src/**/*.c src/*.c) $(RAGEL_TARGETS)
OBJECTS=$(patsubst %.c,%.o,${SOURCES}) $(patsubst %.S,%.o,${ASM})
OBJECTS_EXTERNAL+=$(call get_objs,src/polarssl/library/*.c)
OBJECTS_NOEXT=$(filter-out ${OBJECTS_EXTERNAL},${OBJECTS})
LIB_SRC=$(filter-out src/mongrel2.c,${SOURCES})
LIB_OBJ=$(filter-out src/mongrel2.o,${OBJECTS})
TEST_SRC=$(wildcard tests/*_tests.c)
TESTS=$(patsubst %.c,%,${TEST_SRC})
MAKEOPTS=OPTFLAGS="${NOEXTCFLAGS} ${OPTFLAGS}" OPTLIBS="${OPTLIBS}" LIBS="${LIBS}" DESTDIR="${DESTDIR}" PREFIX="${PREFIX}"
ifdef $($(shell sh init.sh))
endif

all: bin/mongrel2 tests m2sh procer

dev: CFLAGS=-g -Wall -Isrc -Wall -Wextra $(OPTFLAGS) -D_FILE_OFFSET_BITS=64
dev: all

${OBJECTS_NOEXT}: CFLAGS += ${NOEXTCFLAGS}

src/polarssl/include/polarssl/config.h: src/polarssl_config.h
	cp src/polarssl_config.h src/polarssl/include/polarssl/config.h

bin/mongrel2: build/libm2.a src/mongrel2.o
	$(CC) $(CFLAGS) src/mongrel2.o -o $@ $< $(LIBS)

build/libm2.a: CFLAGS += -fPIC
build/libm2.a: build ${LIB_OBJ}
	ar rcs $@ ${LIB_OBJ}
	ranlib $@

build: src/polarssl/include/polarssl/config.h
	@mkdir -p build
	@mkdir -p bin

clean:
	rm -rf build bin lib ${OBJECTS} ${TESTS} tests/config.sqlite
	rm -f tests/perf.log 
	rm -f tests/test.pid 
	rm -f tests/tests.log 
	rm -f tests/empty.sqlite 
	rm -f tools/lemon/lemon
	rm -f tools/m2sh/tests/tests.log 
	find . -name "*.gc*" -exec rm {} \;
	${MAKE} -C tools/m2sh OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/filters OPTLIB=${OPTLIB} clean
	${MAKE} -C tests/filters OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/config_modules OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/procer OPTLIB=${OPTLIB} clean

pristine: clean
	sudo rm -rf examples/python/build examples/python/dist examples/python/m2py.egg-info
	sudo find . -name "*.pyc" -exec rm {} \;
	${MAKE} -C docs/manual clean
	cd docs/ && ${MAKE} clean
	${MAKE} -C examples/kegogi clean
	rm -f logs/*
	rm -f run/*
	${MAKE} -C tools/m2sh pristine
	${MAKE} -C tools/procer pristine

.PHONY: tests
tests: tests/config.sqlite ${TESTS} test_filters filters config_modules
	sh ./tests/runtests.sh

tests/config.sqlite: src/config/config.sql src/config/example.sql src/config/mimetypes.sql
	sqlite3 $@ < src/config/config.sql
	sqlite3 $@ < src/config/example.sql
	sqlite3 $@ < src/config/mimetypes.sql

$(TESTS): %: %.c build/libm2.a
	$(CC) $(CFLAGS) -o $@ $< build/libm2.a $(LIBS)

src/state.c: src/state.rl src/state_machine.rl
src/http11/http11_parser.c: src/http11/http11_parser.rl
src/http11/httpclient_parser.c: src/http11/httpclient_parser.rl

check:
	@echo Files with potentially dangerous functions.
	@egrep '[^_.>a-zA-Z0-9](str(n?cpy|n?cat|xfrm|n?dup|str|pbrk|tok|_)|stpn?cpy|a?sn?printf|byte_)' $(filter-out src/bstr/bsafe.c,${SOURCES})

m2sh: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/m2sh all

procer: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/procer all

test_filters: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tests/filters all

filters: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/filters all

config_modules: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/config_modules all

# Try to install first before creating target directory and trying again
install: all
	install bin/mongrel2 $(DESTDIR)/$(PREFIX)/bin/ \
	    || ( install -d $(DESTDIR)/$(PREFIX)/bin/ \
	        && install bin/mongrel2 $(DESTDIR)/$(PREFIX)/bin/ )
	${MAKE} ${MAKEOPTS} -C tools/m2sh install
	${MAKE} ${MAKEOPTS} -C tools/config_modules install
	${MAKE} ${MAKEOPTS} -C tools/filters install
	${MAKE} ${MAKEOPTS} -C tools/procer install

examples/python/mongrel2/sql/config.sql: src/config/config.sql src/config/mimetypes.sql
	cat src/config/config.sql src/config/mimetypes.sql > $@

ragel:
	ragel -G2 src/state.rl
	ragel -G2 src/http11/http11_parser.rl
	ragel -G2 src/handler_parser.rl
	ragel -G2 src/http11/httpclient_parser.rl

valgrind:
	VALGRIND="valgrind --log-file=/tmp/valgrind-%p.log" ${MAKE}

%.o: %.S
	$(CC) $(CFLAGS) -c $< -o $@

coverage: NOEXTCFLAGS += -fprofile-arcs -ftest-coverage
coverage: LIBS += -lgcov
coverage: LDFLAGS += -fprofile-arcs
coverage: clean all coverage_report

coverage_report:
	rm -rf tests/m2.zcov tests/coverage
	zcov-scan tests/m2.zcov
	zcov-genhtml --root $(CURDIR) tests/m2.zcov tests/coverage
	zcov-summarize tests/m2.zcov

system_tests:
	./tests/system_tests/curl_tests
	./tests/system_tests/chat_tests

manual:
	dexy
	cp docs/manual/Makefile output/docs/manual/
	cp docs/manual/pastie.sty output/docs/manual/
	${MAKE} -C output/docs/manual clean book-final.pdf
	rm -rf output/docs/manual/*.dvi output/docs/manual/*.pdf
	${MAKE} -C output/docs/manual book-final.pdf
	${MAKE} -C output/docs/manual draft

tarball:
	sh maketar.sh mongrel2-${VERSION}

release: tarball
	#git archive --format=tar --prefix=mongrel2-${VERSION}/ v${VERSION} | bzip2 -9 > mongrel2-${VERSION}.tar.bz2
	scp mongrel2-${VERSION}.tar.bz2 ${USER}@mongrel2.org:/var/www/mongrel2.org/static/downloads/
	md5sum mongrel2-${VERSION}.tar.bz2
	curl http://mongrel2.org/static/downloads/mongrel2-${VERSION}.tar.bz2 | md5sum

netbsd: OPTFLAGS += -I/usr/local/include -I/usr/pkg/include
netbsd: OPTLIBS += -L/usr/local/lib -L/usr/pkg/lib
netbsd: LIBS=-lzmq -lsqlite3 $(OPTLIBS)
netbsd: dev


freebsd: OPTFLAGS += -I/usr/local/include
freebsd: OPTLIBS += -L/usr/local/lib -pthread
freebsd: LIBS=-lzmq -lsqlite3 $(OPTLIBS)
freebsd: all

openbsd: OPTFLAGS += -I/usr/local/include
openbsd: OPTLIBS += -L/usr/local/lib -pthread
openbsd: LIBS=-lzmq -lsqlite3 $(OPTLIBS)
openbsd: all

solaris: OPTFLAGS += -I/usr/local/include
solaris: OPTLIBS += -L/usr/local/lib -R/usr/local/lib -lsocket -lnsl -lsendfile
solaris: OPTLIBS += -L/lib -R/lib
solaris: all


macports: OPTFLAGS += -I/opt/local/include
macports: OPTLIBS += -L/opt/local/lib -undefined dynamic_lookup
macports: all

=== examples/kegogi/Makefile ===
CFLAGS=-g -I../../src -Isrc -Wall -Wextra
LIBS=-lzmq -lsqlite3

all: kegogi

install: all
	sudo install build/kegogi /usr/local/bin/

kegogi: src/kegogi.o src/fuzzrnd.o src/kegogi_parser.o src/httpclient.o src/param.o src/kegogi_lexer.o src/kegogi_tokens.o
	mkdir -p build
	gcc ${CFLAGS} -o build/kegogi src/kegogi.o src/kegogi_parser.o src/kegogi_lexer.o src/fuzzrnd.o src/httpclient.o src/param.o src/kegogi_tokens.o ${LIBS} ../../build/libm2.a

src/kegogi_lexer.o: src/kegogi_lexer.c
	gcc $(CFLAGS) -c src/kegogi_lexer.c -o src/kegogi_lexer.o

src/kegogi_lexer.c: src/kegogi_lexer.rl src/kegogi_parser.h
	ragel src/kegogi_lexer.rl -C -o src/kegogi_lexer.c

src/kegogi_parser.c: src/kegogi_parser.y src/kegogi_parser_extra.c lemon
	./lemon src/kegogi_parser.y
	cat src/kegogi_parser_extra.c >> src/kegogi_parser.c
	echo "foo"
clean:
	rm -f src/*.o build/*

=== tests/filters/Makefile ===
PREFIX?=/usr/local
CFLAGS=-I../../src -I../../src/polarssl/include $(OPTFLAGS) -fPIC -shared -nostartfiles -L../../build
LDFLAGS=$(OPTLIBS)

all: test_filter.so test_filter_a.so test_filter_b.so test_filter_c.so


%.so : %.c ../../build/libm2.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< ../../build/libm2.a

clean:
	rm -f *.so

install:
	install -d $(DESTDIR)/$(PREFIX)/lib/mongrel2/filters/
	install *.so $(DESTDIR)/$(PREFIX)/lib/mongrel2/filters/

=== tools/config_modules/Makefile ===
PREFIX?=/usr/local
CFLAGS=-I../../src -I../../src/polarssl/include $(OPTFLAGS) -fPIC -shared -nostartfiles -L../../build
LDFLAGS=$(OPTLIBS)

MONGO_SRC = mongo-c-driver/src/bson.c \
            mongo-c-driver/src/encoding.c \
            mongo-c-driver/src/gridfs.c \
            mongo-c-driver/src/md5.c \
            mongo-c-driver/src/mongo.c \
            mongo-c-driver/src/numbers.c \
            mongo-c-driver/src/env_posix.c
MONGO_CFLAGS = -fPIC -Imongo-c-driver/src -DMONGO_HAVE_STDINT

all: null.so zmq.so

.PHONY: fetch_mongo_c_driver
fetch_mongo_c_driver:
	if test ! -d mongo-c-driver; then git clone https://github.com/mongodb/mongo-c-driver.git; fi
	cd mongo-c-driver && git checkout v0.6
	

mongodb.so: CFLAGS += $(MONGO_CFLAGS)
mongodb.so: fetch_mongo_c_driver
mongodb.so: mongodb.c
	$(CC) $(CFLAGS) -c $(MONGO_SRC)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< bson.o encoding.o gridfs.o md5.o mongo.o env_posix.o numbers.o ../../build/libm2.a

%.so : %.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< ../../build/libm2.a

clean:
	rm -f *.o *.so
	rm -Rf mongo-c-driver

install:
	install -d $(DESTDIR)/$(PREFIX)/lib/mongrel2/config_modules/
	install *.so $(DESTDIR)/$(PREFIX)/lib/mongrel2/config_modules/

=== tools/filters/Makefile ===
PREFIX?=/usr/local
CFLAGS=-I../../src -I../../src/polarssl/include $(OPTFLAGS) -g -fPIC -shared -nostartfiles -L../../build
LDFLAGS=$(OPTLIBS)

all: null.so rewrite.so sendfile.so


%.so : %.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< ../../build/libm2.a

clean:
	rm -f *.so

install:
	install -d $(DESTDIR)/$(PREFIX)/lib/mongrel2/filters/
	install *.so $(DESTDIR)/$(PREFIX)/lib/mongrel2/filters/

=== tools/procer/Makefile ===
CFLAGS=-DNDEBUG -pthread -g -I../../src -Wall $(OPTFLAGS)
PREFIX?=/usr/local
LIBS?=-lzmq 
SOURCES=$(wildcard *.c)
OBJECTS=$(patsubst %.c,%.o,${SOURCES})

all: procer


procer: ../../build/libm2.a ${OBJECTS}
	gcc $(OPTFLAGS) $(OPTLIBS) -o $@ ${OBJECTS} ../../build/libm2.a ${LIBS}

clean:
	rm -f *.o procer

pristine:
	rm -f *.o procer

install: procer
	install procer $(DESTDIR)$(PREFIX)/bin/

=== debian/changelog ===
mongrel2 (1.9.1-6+deb8u1) jessie; urgency=medium

  * Comment out failing test caused by an expired certificate.
    (Closes: Bug#804331)

 -- Jan Niehusmann <jan@debian.org>  Thu, 25 Feb 2016 22:56:00 +0100

mongrel2 (1.9.1-6) unstable; urgency=low

  * Update Vcs URL
  * remove runit-related files and logfiles when purging mongrel2-run
  * compile tests and examples using hardening flags

 -- Jan Niehusmann <jan@debian.org>  Mon, 28 Jul 2014 11:57:37 +0200

mongrel2 (1.9.1-5) unstable; urgency=low

  * Use glibc implementation of setcontext/getcontext.
    (Closes: Bug#754194)

 -- Jan Niehusmann <jan@debian.org>  Tue, 08 Jul 2014 21:10:07 +0200

mongrel2 (1.9.1-4) unstable; urgency=low

  * Fix build on kfreebsd. (Closes: Bug#754161)

 -- Jan Niehusmann <jan@debian.org>  Tue, 08 Jul 2014 11:41:41 +0200

mongrel2 (1.9.1-3) unstable; urgency=low

  * Fix build on big endian machines. (Closes: Bug#754156)

 -- Jan Niehusmann <jan@debian.org>  Tue, 08 Jul 2014 01:10:32 +0200

mongrel2 (1.9.1-2) unstable; urgency=low

  * Add package 'mongrel2-run' containing infrastructure to
    start mongrel2 as a server on boot, using runit

 -- Jan Niehusmann <jan@debian.org>  Mon, 16 Jun 2014 16:26:20 +0200

mongrel2 (1.9.1-1) experimental; urgency=low

  * Update to upstream release 1.9.1
  * remove binary .swf files from source tarball
  * revert certificate workaround (fixed upstream)

 -- Jan Niehusmann <jan@debian.org>  Wed, 11 Jun 2014 15:26:26 +0200

mongrel2 (1.9.0-2) experimental; urgency=low

  * Build against libzmq3 (closes: Bug#740416)
  * Set standards-version to 3.9.5 (no changes)
  * Work around built failure due to expired certificate in
    test case (https://github.com/zedshaw/mongrel2/issues/205)
    by skipping that part of the test.

 -- Jan Niehusmann <jan@debian.org>  Sat, 01 Mar 2014 23:04:27 +0100

mongrel2 (1.9.0-1) experimental; urgency=low

  * Import latest changes from upstream git (tag 'v1.9.0')

 -- Jan Niehusmann <jan@debian.org>  Fri, 14 Feb 2014 15:24:48 +0100

mongrel2 (1.9.0~rc-20131012-1) experimental; urgency=low

  * Import latest changes from upstream git ('release/1.9.0' branch)

 -- Jan Niehusmann <jan@debian.org>  Sun, 24 Nov 2013 22:42:38 +0100

mongrel2 (1.8.1-devel-20130916-1) experimental; urgency=low

  * Import latest changes from upstream git (develop branch).

 -- Jan Niehusmann <jan@debian.org>  Wed, 18 Sep 2013 12:29:20 +0200

mongrel2 (1.8.1-devel-20130603-1) experimental; urgency=low

  * Initial release (Closes: #590629)

 -- Jan Niehusmann <jan@debian.org>  Mon, 03 Jun 2013 16:30:11 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# enable hardening
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk



%:
	dh $@ --parallel

override_dh_auto_install:
	$(MAKE) DESTDIR="$$(pwd)/debian/tmp" PREFIX=/usr install

override_dh_installexamples:
	dh_installexamples
	find "$$(pwd)/debian/mongrel2-core" -name "*.css" -perm +a+x -exec chmod -x "{}" \;

=== debian/watch ===
version=3
opts=dversionmangle=s/-devel.*\d*$// \
  http://githubredir.debian.net/github/zedshaw/mongrel2/ v(.+)\.tar\.gz

## mongrel2 1.9.2

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,18 @@
 TEST_SRC=$(wildcard tests/*_tests.c)
 TESTS=$(patsubst %.c,%,${TEST_SRC})
 MAKEOPTS=OPTFLAGS="${NOEXTCFLAGS} ${OPTFLAGS}" OPTLIBS="${OPTLIBS}" LIBS="${LIBS}" DESTDIR="${DESTDIR}" PREFIX="${PREFIX}"
-ifdef $($(shell sh init.sh))
+
+# Prepare PolarSSL git submodule
+# 
+# - Perform src/polarssl submodule init and update, if necessary.  This is executed
+#   upon every make invocation, and must be done before the SOURCES variable, above
+#   is lazily evaluated, or none of the src/polarssl source files will be found
+
+ifdef $($(shell									\
+	if git submodule status | grep '^-'; then				\
+	    echo "PolarSSL; init and update git submodule" 1>&2;		\
+	    git submodule init && git submodule update;				\
+	fi ))
 endif
 
 all: bin/mongrel2 tests m2sh procer
@@ -25,8 +36,46 @@
 
 ${OBJECTS_NOEXT}: CFLAGS += ${NOEXTCFLAGS}
 
-src/polarssl/include/polarssl/config.h: src/polarssl_config.h
-	cp src/polarssl_config.h src/polarssl/include/polarssl/config.h
+# 
+# CFLAGS_DEFS: The $(CC) flags required to obtain C pre-processor #defines, per:
+# 
+#   http://nadeausoftware.com/articles/2011/12/c_c_tip_how_list_compiler_predefined_macros
+# 
+# It may be appropriate to copy some of these platform-specific CFLAGS_DEFS assignments into the
+# appropriate platform target at the end of this file, eg:
+# 
+#   solaris: CFLAGS_DEF=...
+#   solaris: all
+
+#CFLAGS_DEFS=-dM -E		# Portland Group PGCC
+#CFLAGS_DEFS=-xdumpmacros -E	# Oracle Solaris Studio
+#CFLAGS_DEFS=-qshowmacros -E	# IBM XL C
+CFLAGS_DEFS=-dM -E -x c 	# clang, gcc, HP C, Intel icc
+
+# Configure PolarSSL
+# 
+# - check for required src/polarssl/include/polarssl/config.h definitions
+#   and patch using version-appropriate src/polarssl_config.patch.#.#.# file:
+#   - If desired PolarSSL version is not yet supported, git checkout the
+#     new src/polarssl/ version X.Y.Z, edit its include/polarssl/config.h as
+#     required, and generate a new src/polarssl_config.patch.X.Y.Z using:
+# 
+#         git diff -- include/polarssl/config.h > ../polarssl_config.patch.X.Y.Z
+FORCE:
+src/polarssl/include/polarssl/config.h: src/polarssl/include/polarssl/version.h FORCE
+	@POLARSSL_VERSION=$$( $(CC) $(CFLAGS_DEFS) $<				\
+	    | sed -n -e 's/^.*POLARSSL_VERSION_STRING[\t ]*"\([^"]*\)".*/\1/p' ); \
+	if $(CC) $(CFLAGS_DEFS) $@ | grep -q POLARSSL_HAVEGE_C; then		\
+	    echo "PolarSSL $${POLARSSL_VERSION}; already configured";		\
+	else									\
+	    echo "PolarSSL $${POLARSSL_VERSION}; defining POLARSSL_HAVEGE_C...";\
+	    POLARSSL_PATCH=src/polarssl_config.patch.$${POLARSSL_VERSION};	\
+	    if ! patch -d src/polarssl -p 1 < $${POLARSSL_PATCH}; then		\
+		echo "*** Failed to apply $${POLARSSL_PATCH}";			\
+		exit 1;								\
+	    fi;									\
+	fi
+
 
 bin/mongrel2: build/libm2.a src/mongrel2.o
 	$(CC) $(CFLAGS) src/mongrel2.o -o $@ $< $(LIBS)
@@ -48,7 +97,8 @@
 	rm -f tests/empty.sqlite 
 	rm -f tools/lemon/lemon
 	rm -f tools/m2sh/tests/tests.log 
-	find . -name "*.gc*" -exec rm {} \;
+	find . \( -name "*.gcno" -o -name "*.gcda" \) -exec rm {} \;
+	git -C src/polarssl checkout include/polarssl/config.h
 	${MAKE} -C tools/m2sh OPTLIB=${OPTLIB} clean
 	${MAKE} -C tools/filters OPTLIB=${OPTLIB} clean
 	${MAKE} -C tests/filters OPTLIB=${OPTLIB} clean
@@ -65,6 +115,7 @@
 	rm -f run/*
 	${MAKE} -C tools/m2sh pristine
 	${MAKE} -C tools/procer pristine
+	git submodule deinit -f src/polarssl
 
 .PHONY: tests
 tests: tests/config.sqlite ${TESTS} test_filters filters config_modules
@@ -122,6 +173,8 @@
 
 valgrind:
 	VALGRIND="valgrind --log-file=/tmp/valgrind-%p.log" ${MAKE}
+strace:
+	VALGRIND="strace" ${MAKE}
 
 %.o: %.S
 	$(CC) $(CFLAGS) -c $< -o $@

=== debian/changelog ===
mongrel2 (1.9.2-1) unstable; urgency=low

  * Update to upstream release 1.9.2
  * Update watch file (Closes: Bug#782508)
  * Build with -std=gnu89 to fix building on gcc-5 (Closes: Bug#778013)
  * Set standards-version to 3.9.6 (no changes)

 -- Jan Niehusmann <jan@debian.org>  Wed, 15 Apr 2015 00:13:23 +0200

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,7 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
-
+CFLAGS += -std=gnu89
 
 %:
 	dh $@ --parallel

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/mongrel2-$1\.tar\.gz/ \
  https://github.com/zedshaw/mongrel2/releases .*/v?(\d\S*)\.tar\.gz

## mongrel2 1.10.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-CFLAGS=-g -O2 -Wall -Wextra -Isrc -Isrc/polarssl/include -pthread -rdynamic -DNDEBUG $(OPTFLAGS) -D_FILE_OFFSET_BITS=64
+CFLAGS=-g -O2 -Wall -Wextra -Isrc -Isrc/mbedtls/include -pthread -rdynamic -DNDEBUG $(OPTFLAGS) -D_FILE_OFFSET_BITS=64
 LIBS=-lzmq -ldl -lsqlite3 $(OPTLIBS)
 PREFIX?=/usr/local
 
@@ -6,9 +6,9 @@
 
 ASM=$(wildcard src/**/*.S src/*.S)
 RAGEL_TARGETS=src/state.c src/http11/http11_parser.c
-SOURCES=$(wildcard src/polarssl/library/*.c src/**/*.c src/*.c) $(RAGEL_TARGETS)
+SOURCES=$(wildcard src/mbedtls/library/*.c src/**/*.c src/*.c) $(RAGEL_TARGETS)
 OBJECTS=$(patsubst %.c,%.o,${SOURCES}) $(patsubst %.S,%.o,${ASM})
-OBJECTS_EXTERNAL+=$(call get_objs,src/polarssl/library/*.c)
+OBJECTS_EXTERNAL+=$(call get_objs,src/mbedtls/library/*.c)
 OBJECTS_NOEXT=$(filter-out ${OBJECTS_EXTERNAL},${OBJECTS})
 LIB_SRC=$(filter-out src/mongrel2.c,${SOURCES})
 LIB_OBJ=$(filter-out src/mongrel2.o,${OBJECTS})
@@ -16,25 +16,26 @@
 TESTS=$(patsubst %.c,%,${TEST_SRC})
 MAKEOPTS=OPTFLAGS="${NOEXTCFLAGS} ${OPTFLAGS}" OPTLIBS="${OPTLIBS}" LIBS="${LIBS}" DESTDIR="${DESTDIR}" PREFIX="${PREFIX}"
 
-# Prepare PolarSSL git submodule
-# 
-# - Perform src/polarssl submodule init and update, if necessary.  This is executed
+# Prepare mbedtls git submodule
+# 
+# - Perform src/mbedtls submodule init and update, if necessary.  This is executed
 #   upon every make invocation, and must be done before the SOURCES variable, above
-#   is lazily evaluated, or none of the src/polarssl source files will be found
+#   is lazily evaluated, or none of the src/mbedtls source files will be found
 
 ifdef $($(shell									\
 	if git submodule status | grep '^-'; then				\
-	    echo "PolarSSL; init and update git submodule" 1>&2;		\
+	    echo "mbedtls; init and update git submodule" 1>&2;		\
 	    git submodule init && git submodule update;				\
 	fi ))
 endif
 
-all: bin/mongrel2 tests m2sh procer
+all: builddirs bin/mongrel2 tests m2sh procer
 
 dev: CFLAGS=-g -Wall -Isrc -Wall -Wextra $(OPTFLAGS) -D_FILE_OFFSET_BITS=64
 dev: all
 
 ${OBJECTS_NOEXT}: CFLAGS += ${NOEXTCFLAGS}
+${OBJECTS}: src/mbedtls/include/polarssl/config.h
 
 # 
 # CFLAGS_DEFS: The $(CC) flags required to obtain C pre-processor #defines, per:
@@ -52,42 +53,42 @@
 #CFLAGS_DEFS=-qshowmacros -E	# IBM XL C
 CFLAGS_DEFS=-dM -E -x c 	# clang, gcc, HP C, Intel icc
 
-# Configure PolarSSL
-# 
-# - check for required src/polarssl/include/polarssl/config.h definitions
+# Configure mbedtls
+# 
+# - check for required src/mbedtls/include/polarssl/config.h definitions
 #   and patch using version-appropriate src/polarssl_config.patch.#.#.# file:
-#   - If desired PolarSSL version is not yet supported, git checkout the
-#     new src/polarssl/ version X.Y.Z, edit its include/polarssl/config.h as
+#   - If desired mbedtls version is not yet supported, git checkout the
+#     new src/mbedtls/ version X.Y.Z, edit its include/polarssl/config.h as
 #     required, and generate a new src/polarssl_config.patch.X.Y.Z using:
 # 
 #         git diff -- include/polarssl/config.h > ../polarssl_config.patch.X.Y.Z
 FORCE:
-src/polarssl/include/polarssl/config.h: src/polarssl/include/polarssl/version.h FORCE
+src/mbedtls/include/polarssl/config.h: src/mbedtls/include/polarssl/version.h FORCE
 	@POLARSSL_VERSION=$$( $(CC) $(CFLAGS_DEFS) $<				\
 	    | sed -n -e 's/^.*POLARSSL_VERSION_STRING[\t ]*"\([^"]*\)".*/\1/p' ); \
 	if $(CC) $(CFLAGS_DEFS) $@ | grep -q POLARSSL_HAVEGE_C; then		\
-	    echo "PolarSSL $${POLARSSL_VERSION}; already configured";		\
+	    echo "mbedtls $${POLARSSL_VERSION}; already configured";		\
 	else									\
-	    echo "PolarSSL $${POLARSSL_VERSION}; defining POLARSSL_HAVEGE_C...";\
+	    echo "mbedtls $${POLARSSL_VERSION}; defining POLARSSL_HAVEGE_C...";\
 	    POLARSSL_PATCH=src/polarssl_config.patch.$${POLARSSL_VERSION};	\
-	    if ! patch -d src/polarssl -p 1 < $${POLARSSL_PATCH}; then		\
+	    if ! patch -d src/mbedtls -p 1 < $${POLARSSL_PATCH}; then		\
 		echo "*** Failed to apply $${POLARSSL_PATCH}";			\
 		exit 1;								\
 	    fi;									\
 	fi
 
+.PHONY: builddirs
+builddirs:
+	@mkdir -p build
+	@mkdir -p bin
 
 bin/mongrel2: build/libm2.a src/mongrel2.o
 	$(CC) $(CFLAGS) src/mongrel2.o -o $@ $< $(LIBS)
 
 build/libm2.a: CFLAGS += -fPIC
-build/libm2.a: build ${LIB_OBJ}
+build/libm2.a: ${LIB_OBJ}
 	ar rcs $@ ${LIB_OBJ}
 	ranlib $@
-
-build: src/polarssl/include/polarssl/config.h
-	@mkdir -p build
-	@mkdir -p bin
 
 clean:
 	rm -rf build bin lib ${OBJECTS} ${TESTS} tests/config.sqlite
@@ -98,7 +99,7 @@
 	rm -f tools/lemon/lemon
 	rm -f tools/m2sh/tests/tests.log 
 	find . \( -name "*.gcno" -o -name "*.gcda" \) -exec rm {} \;
-	git -C src/polarssl checkout include/polarssl/config.h
+	if test -e .git; then git -C src/mbedtls checkout include/polarssl/config.h; fi
 	${MAKE} -C tools/m2sh OPTLIB=${OPTLIB} clean
 	${MAKE} -C tools/filters OPTLIB=${OPTLIB} clean
 	${MAKE} -C tests/filters OPTLIB=${OPTLIB} clean
@@ -115,7 +116,7 @@
 	rm -f run/*
 	${MAKE} -C tools/m2sh pristine
 	${MAKE} -C tools/procer pristine
-	git submodule deinit -f src/polarssl
+	git submodule deinit -f src/mbedtls
 
 .PHONY: tests
 tests: tests/config.sqlite ${TESTS} test_filters filters config_modules

=== docs/manual/Makefile ===
JUNK_FILES=book-final.* *.aux *.log styles/*.aux
SOURCE=book
WEBSITE=$(USER)@mongrel2.org:/var/www/mongrel2.org/static/
FINAL=book-final

draft: book-final.dvi
	htlatex book-final.tex "book,index=1,2,next,fn-in"

book-final.dvi:
	cp $(SOURCE).tex book-final.tex
	latex -halt-on-error book-final.tex

book-final.pdf: book-final.dvi
	dvipdf book-final.dvi

view: book-final.pdf
	evince book-final.pdf

clean:
	rm -rf $(JUNK_FILES)
	find . -name "*.aux" -exec rm {} \;

release: clean book-final.pdf draft book-final.pdf sync

sync:
	rsync -vz $(FINAL).pdf $(WEBSITE)/mongrel2-manual.pdf
	rsync -vz $(FINAL).html $(WEBSITE)/mongrel2-manual.html
	rsync -vz $(FINAL).css $(FINAL)*.html $(WEBSITE)/

=== docs/site/Makefile ===
WEBSITE=~/mongrel2.org/site-root

all:
	rsync -a --delete assets/ output/
	lua gensite.lua output
	bash -c 'cp -a ../../output/docs/manual/*.{html,css} output/manual'

clean:
	rm -rf output

sync: all
	rsync -avz output/* $(WEBSITE)/

=== debian/changelog ===
mongrel2 (1.10.0-2) unstable; urgency=medium

  * Use "find -perm /xxx" instead of "find -perm +xxx" in debian/rules
    (Closes: Bug#803023)
  * Move dh_installexamples to override_dh_installexamples-arch
    (Closes: Bug#806079)

 -- Jan Niehusmann <jan@debian.org>  Tue, 24 Nov 2015 17:17:48 +0100

mongrel2 (1.10.0-1) unstable; urgency=low

  * Fix build log checks warnings
  * Update debian/watch
  * Upgrade to upstream version 1.10.0
  * Revert upstream switch to mbedtls (new name of polarssl)

 -- Jan Niehusmann <jan@debian.org>  Sat, 24 Oct 2015 11:04:10 +0200

=== debian/control ===
Source: mongrel2
Section: httpd
Priority: optional
Maintainer: Jan Niehusmann <jan@debian.org>
Build-Depends: debhelper (>= 8.0.0), libzmq3-dev (>= 2.1), libsqlite3-dev (>= 3.0), sqlite3 (>= 3.0), libpolarssl-dev (>= 1.2.3), dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.6
Homepage: http://mongrel2.org/
Vcs-Git: git://anonscm.debian.org/users/jan/mongrel2.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/jan/mongrel2.git;a=summary

Package: mongrel2-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programming language agnostic web server (binaries)
 Mongrel2 is an application, programming language, and network
 architecture agnostic web server that focuses on web applications using
 modern browser technologies.
 .
 Mongrel2 supports 17 languages and platforms, HTTP, Flash sockets,
 WebSockets, Long Polling, and many ways to deploy and hack on it.
 .
 This package includes the server binaries but doesn't contain all the
 infrastructure needed to setup a standalone web server.


Package: mongrel2-run
Architecture: all
Depends: mongrel2-core (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, runit, adduser
Description: programming language agnostic web server
 Mongrel2 is an application, programming language, and network
 architecture agnostic web server that focuses on web applications using
 modern browser technologies.
 .
 Mongrel2 supports 17 languages and platforms, HTTP, Flash sockets,
 WebSockets, Long Polling, and many ways to deploy and hack on it.
 .
 This package includes the infrastructure needed to setup a standalone
 web server. Starting mongrel2 at boot is done using runit.

## mongrel2 1.11.0

=== Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 dev: all
 
 ${OBJECTS_NOEXT}: CFLAGS += ${NOEXTCFLAGS}
-${OBJECTS}: src/mbedtls/include/polarssl/config.h
+${OBJECTS}: src/mbedtls/include/mbedtls/config.h
 
 # 
 # CFLAGS_DEFS: The $(CC) flags required to obtain C pre-processor #defines, per:
@@ -55,24 +55,24 @@
 
 # Configure mbedtls
 # 
-# - check for required src/mbedtls/include/polarssl/config.h definitions
-#   and patch using version-appropriate src/polarssl_config.patch.#.#.# file:
+# - check for required src/mbedtls/include/mbedtls/config.h definitions
+#   and patch using version-appropriate src/mbedtls_config.patch.#.#.# file:
 #   - If desired mbedtls version is not yet supported, git checkout the
-#     new src/mbedtls/ version X.Y.Z, edit its include/polarssl/config.h as
-#     required, and generate a new src/polarssl_config.patch.X.Y.Z using:
-# 
-#         git diff -- include/polarssl/config.h > ../polarssl_config.patch.X.Y.Z
+#     new src/mbedtls/ version X.Y.Z, edit its include/mbedtls/config.h as
+#     required, and generate a new src/mbedtls_config.patch.X.Y.Z using:
+# 
+#         git diff -- include/mbedtls/config.h > ../mbedtls_config.patch.X.Y.Z
 FORCE:
-src/mbedtls/include/polarssl/config.h: src/mbedtls/include/polarssl/version.h FORCE
-	@POLARSSL_VERSION=$$( $(CC) $(CFLAGS_DEFS) $<				\
-	    | sed -n -e 's/^.*POLARSSL_VERSION_STRING[\t ]*"\([^"]*\)".*/\1/p' ); \
-	if $(CC) $(CFLAGS_DEFS) $@ | grep -q POLARSSL_HAVEGE_C; then		\
-	    echo "mbedtls $${POLARSSL_VERSION}; already configured";		\
+src/mbedtls/include/mbedtls/config.h: src/mbedtls/include/mbedtls/version.h FORCE
+	@MBEDTLS_VERSION=$$( $(CC) $(CFLAGS_DEFS) $<				\
+	    | sed -n -e 's/^.*MBEDTLS_VERSION_STRING[\t ]*"\([^"]*\)".*/\1/p' ); \
+	if $(CC) $(CFLAGS_DEFS) $@ | grep -q MBEDTLS_HAVEGE_C; then		\
+	    echo "mbedtls $${MBEDTLS_VERSION}; already configured";		\
 	else									\
-	    echo "mbedtls $${POLARSSL_VERSION}; defining POLARSSL_HAVEGE_C...";\
-	    POLARSSL_PATCH=src/polarssl_config.patch.$${POLARSSL_VERSION};	\
-	    if ! patch -d src/mbedtls -p 1 < $${POLARSSL_PATCH}; then		\
-		echo "*** Failed to apply $${POLARSSL_PATCH}";			\
+	    echo "mbedtls $${MBEDTLS_VERSION}; defining MBEDTLS_HAVEGE_C...";\
+	    MBEDTLS_PATCH=src/mbedtls_config.patch.$${MBEDTLS_VERSION};	\
+	    if ! patch -d src/mbedtls -p 1 < $${MBEDTLS_PATCH}; then		\
+		echo "*** Failed to apply $${MBEDTLS_PATCH}";			\
 		exit 1;								\
 	    fi;									\
 	fi
@@ -98,8 +98,9 @@
 	rm -f tests/empty.sqlite 
 	rm -f tools/lemon/lemon
 	rm -f tools/m2sh/tests/tests.log 
+	rm -rf release-scripts/output
 	find . \( -name "*.gcno" -o -name "*.gcda" \) -exec rm {} \;
-	if test -e .git; then git -C src/mbedtls checkout include/polarssl/config.h; fi
+	if test -e .git; then git -C src/mbedtls checkout include/mbedtls/config.h; fi
 	${MAKE} -C tools/m2sh OPTLIB=${OPTLIB} clean
 	${MAKE} -C tools/filters OPTLIB=${OPTLIB} clean
 	${MAKE} -C tests/filters OPTLIB=${OPTLIB} clean

=== tests/filters/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PREFIX?=/usr/local
-CFLAGS=-I../../src -I../../src/polarssl/include $(OPTFLAGS) -fPIC -shared -nostartfiles -L../../build
+CFLAGS=-I../../src -I../../src/mbedtls/include $(OPTFLAGS) -fPIC -shared -nostartfiles -L../../build
 LDFLAGS=$(OPTLIBS)
 
 all: test_filter.so test_filter_a.so test_filter_b.so test_filter_c.so

=== debian/changelog ===
mongrel2 (1.11.0-7build1) bionic; urgency=medium

  * No-change rebuild against libmbedcrypto1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Feb 2018 08:45:31 +0000

mongrel2 (1.11.0-7) unstable; urgency=medium

  * Add -shared flag when building shared libraries. Overrides -fPIE,
    fixing build errors with older versions of dpkg-dev (eg. on ubuntu).
    Hint found at https://lists.debian.org/debian-devel/2016/05/msg00302.html

 -- Jan Niehusmann <jan@debian.org>  Thu, 02 Mar 2017 16:49:48 +0100

mongrel2 (1.11.0-6) unstable; urgency=medium

  * Cherry-pick upstream patch.
    One can send HUP signals to mongrel2 to make it reopen the log
    files. Due to a bug, after receiving two such signals, mongrel2
    stopped working. This bug is fixed by the patch.

 -- Jan Niehusmann <jan@debian.org>  Wed, 22 Feb 2017 12:14:48 +0100

mongrel2 (1.11.0-5) unstable; urgency=medium

  * Sort output of $(wildcard ...) in subdirectory Makefiles

 -- Jan Niehusmann <jan@debian.org>  Wed, 21 Dec 2016 17:54:59 +0100

mongrel2 (1.11.0-4) unstable; urgency=medium

  * Disable test_Unixy_chroot_fails on GNU/hurd

 -- Jan Niehusmann <jan@debian.org>  Wed, 21 Dec 2016 01:10:23 +0100

mongrel2 (1.11.0-3) unstable; urgency=medium

  * Sort output of $(wildcard ...) in Makefile to
    fix reproducible builds.
    (https://reproducible-builds.org/docs/stable-inputs/)
  * remove unused function Unixy_getcwd()
    uses non-portable PATH_MAX which is not available on hurd
  * provide alternative implementation of normalize_path not using
    PATH_MAX (should fix build on hurd)

 -- Jan Niehusmann <jan@debian.org>  Tue, 20 Dec 2016 21:19:07 +0100

mongrel2 (1.11.0-2) unstable; urgency=medium

  * Update Vcs-Browser URL
  * Enable hardening=+all flag
  * Set debhelper compat level to 10
  * Override source-is-missing lintian warning
  * Set Standards-Version: 3.9.8

 -- Jan Niehusmann <jan@debian.org>  Mon, 19 Dec 2016 17:12:57 +0100

mongrel2 (1.11.0-1) unstable; urgency=medium

  * Update to upstream release 1.11.0

 -- Jan Niehusmann <jan@debian.org>  Thu, 11 Feb 2016 22:43:11 +0100

mongrel2 (1.10.0-3) unstable; urgency=medium

  * Port to mbedtls 2.x (patch by Justin Karneges)
    (Closes: Bug#808063)

 -- Jan Niehusmann <jan@debian.org>  Thu, 17 Dec 2015 12:35:03 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: mongrel2
 Section: httpd
 Priority: optional
-Maintainer: Jan Niehusmann <jan@debian.org>
-Build-Depends: debhelper (>= 8.0.0), libzmq3-dev (>= 2.1), libsqlite3-dev (>= 3.0), sqlite3 (>= 3.0), libpolarssl-dev (>= 1.2.3), dpkg-dev (>= 1.16.1~)
-Standards-Version: 3.9.6
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jan Niehusmann <jan@debian.org>
+Build-Depends: debhelper (>= 10.0.0), libzmq3-dev (>= 2.1), libsqlite3-dev (>= 3.0), sqlite3 (>= 3.0), libmbedtls-dev, dpkg-dev (>= 1.16.1~)
+Standards-Version: 3.9.8
 Homepage: http://mongrel2.org/
 Vcs-Git: git://anonscm.debian.org/users/jan/mongrel2.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/jan/mongrel2.git;a=summary
+Vcs-Browser: https://anonscm.debian.org/cgit/users/jan/mongrel2.git
 
 Package: mongrel2-core
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 export DH_OPTIONS
 
 # enable hardening
-#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
@@ -29,7 +29,7 @@
 override_dh_auto_install:
 	$(MAKE) DESTDIR="$$(pwd)/debian/tmp" PREFIX=/usr install
 
-override_dh_installexamples:
+override_dh_installexamples-arch:
 	dh_installexamples
-	find "$$(pwd)/debian/mongrel2-core" -name "*.css" -perm +a+x -exec chmod -x "{}" \;
+	find "$$(pwd)/debian/mongrel2-core" -name "*.css" -perm /a+x -exec chmod -x "{}" \;

## mongrel2 1.12.0

=== Makefile ===
CFLAGS?=-g -O2
CFLAGS += -Wall -Wextra -I./src -DNDEBUG -D_FILE_OFFSET_BITS=64 -pthread
CFLAGS += ${OPTFLAGS}
LIBS+=-lzmq -ldl -lsqlite3 -lmbedtls -lmbedx509 -lmbedcrypto
PREFIX?=/usr/local

get_objs = $(addsuffix .o,$(basename $(wildcard $(1))))

ASM=$(wildcard src/**/*.S src/*.S)
RAGEL_TARGETS=src/state.c src/http11/http11_parser.c
SOURCES=$(wildcard src/**/*.c src/*.c) $(RAGEL_TARGETS)
OBJECTS=$(patsubst %.c,%.o,${SOURCES}) $(patsubst %.S,%.o,${ASM})
OBJECTS_NOEXT=$(filter-out ${OBJECTS_EXTERNAL},${OBJECTS})
LIB_SRC=$(filter-out src/mongrel2.c,${SOURCES})
LIB_OBJ=$(filter-out src/mongrel2.o,${OBJECTS})
TEST_SRC=$(wildcard tests/*_tests.c)
TESTS=$(patsubst %.c,%,${TEST_SRC})
MAKEOPTS=OPTFLAGS="${CFLAGS} ${NOEXTCFLAGS} ${OPTFLAGS}" LIBS="${LIBS}" DESTDIR="${DESTDIR}" PREFIX="${PREFIX}"

all: bin/mongrel2 tests m2sh procer

${OBJECTS_NOEXT}: CFLAGS += ${NOEXTCFLAGS}
${OBJECTS}: | builddirs

.PHONY: builddirs
builddirs:
	@mkdir -p build
	@mkdir -p bin

bin/mongrel2: build/libm2.a src/mongrel2.o
	$(CC) $(CFLAGS) $(LDFLAGS) src/mongrel2.o -o $@ $< $(LIBS)

build/libm2.a: CFLAGS += -fPIC
build/libm2.a: ${LIB_OBJ}
	ar rcs $@ ${LIB_OBJ}
	ranlib $@

clean:
	rm -rf build bin lib ${OBJECTS} ${TESTS} tests/config.sqlite
	rm -f tests/perf.log 
	rm -f tests/test.pid 
	rm -f tests/tests.log 
	rm -f tests/empty.sqlite 
	rm -f tools/lemon/lemon
	rm -f tools/m2sh/tests/tests.log 
	rm -rf release-scripts/output
	find . \( -name "*.gcno" -o -name "*.gcda" \) -exec rm {} \;
	${MAKE} -C tools/m2sh OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/filters OPTLIB=${OPTLIB} clean
	${MAKE} -C tests/filters OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/config_modules OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/procer OPTLIB=${OPTLIB} clean

pristine: clean
	sudo rm -rf examples/python/build examples/python/dist examples/python/m2py.egg-info
	sudo find . -name "*.pyc" -exec rm {} \;
	${MAKE} -C docs/manual clean
	cd docs/ && ${MAKE} clean
	${MAKE} -C examples/kegogi clean
	rm -f logs/*
	rm -f run/*
	${MAKE} -C tools/m2sh pristine
	${MAKE} -C tools/procer pristine

.PHONY: tests
tests: tests/config.sqlite ${TESTS} test_filters filters config_modules
	sh ./tests/runtests.sh

tests/config.sqlite: src/config/config.sql src/config/example.sql src/config/mimetypes.sql
	sqlite3 $@ < src/config/config.sql
	sqlite3 $@ < src/config/example.sql
	sqlite3 $@ < src/config/mimetypes.sql

$(TESTS): %: %.c build/libm2.a
	$(CC) $(CFLAGS) -o $@ $< build/libm2.a $(LIBS)

src/state.c: src/state.rl src/state_machine.rl
src/http11/http11_parser.c: src/http11/http11_parser.rl
src/http11/httpclient_parser.c: src/http11/httpclient_parser.rl

check:
	@echo Files with potentially dangerous functions.
	@egrep '[^_.>a-zA-Z0-9](str(n?cpy|n?cat|xfrm|n?dup|str|pbrk|tok|_)|stpn?cpy|a?sn?printf|byte_)' $(filter-out src/bstr/bsafe.c,${SOURCES})

m2sh: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/m2sh all

procer: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/procer all

test_filters: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tests/filters all

filters: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/filters all

config_modules: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/config_modules all

# Try to install first before creating target directory and trying again
install: all
	install bin/mongrel2 $(DESTDIR)/$(PREFIX)/bin/ \
	    || ( install -d $(DESTDIR)/$(PREFIX)/bin/ \
	        && install bin/mongrel2 $(DESTDIR)/$(PREFIX)/bin/ )
	${MAKE} ${MAKEOPTS} -C tools/m2sh install
	${MAKE} ${MAKEOPTS} -C tools/config_modules install
	${MAKE} ${MAKEOPTS} -C tools/filters install
	${MAKE} ${MAKEOPTS} -C tools/procer install

examples/python/mongrel2/sql/config.sql: src/config/config.sql src/config/mimetypes.sql
	cat src/config/config.sql src/config/mimetypes.sql > $@

ragel:
	ragel -G2 src/state.rl
	ragel -G2 src/http11/http11_parser.rl
	ragel -G2 src/handler_parser.rl
	ragel -G2 src/http11/httpclient_parser.rl

%.o: %.S
	$(CC) $(CFLAGS) -c $< -o $@

valgrind:
	VALGRIND="valgrind --log-file=/tmp/valgrind-%p.log" ${MAKE}
strace:
	VALGRIND="strace" ${MAKE}

%.o: %.S
	$(CC) $(CFLAGS) -c $< -o $@

coverage: NOEXTCFLAGS += -fprofile-arcs -ftest-coverage
coverage: LIBS += -lgcov
coverage: LDFLAGS += -fprofile-arcs
coverage: clean all coverage_report

coverage_report:
	rm -rf tests/m2.zcov tests/coverage
	zcov-scan tests/m2.zcov
	zcov-genhtml --root $(CURDIR) tests/m2.zcov tests/coverage
	zcov-summarize tests/m2.zcov

system_tests:
	./tests/system_tests/curl_tests
	./tests/system_tests/chat_tests

manual:
	dexy
	cp docs/manual/Makefile output/docs/manual/
	cp docs/manual/pastie.sty output/docs/manual/
	${MAKE} -C output/docs/manual clean book-final.pdf
	rm -rf output/docs/manual/*.dvi output/docs/manual/*.pdf
	${MAKE} -C output/docs/manual book-final.pdf
	${MAKE} -C output/docs/manual draft

tarball:
	sh maketar.sh mongrel2-${VERSION}

release: tarball
	#git archive --format=tar --prefix=mongrel2-${VERSION}/ v${VERSION} | bzip2 -9 > mongrel2-${VERSION}.tar.bz2
	scp mongrel2-${VERSION}.tar.bz2 ${USER}@mongrel2.org:/var/www/mongrel2.org/static/downloads/
	md5sum mongrel2-${VERSION}.tar.bz2
	curl http://mongrel2.org/static/downloads/mongrel2-${VERSION}.tar.bz2 | md5sum

netbsd: OPTFLAGS += -I/usr/local/include -I/usr/pkg/include
netbsd: LDFLAGS += -L/usr/local/lib -L/usr/pkg/lib
netbsd: LIBS=-lzmq -lsqlite3 $(LDFLAGS)
netbsd: dev


freebsd: OPTFLAGS += -I/usr/local/include
freebsd: LDFLAGS += -L/usr/local/lib -pthread
freebsd: LIBS=-lzmq -lsqlite3 $(LDFLAGS)
freebsd: all

openbsd: OPTFLAGS += -I/usr/local/include
openbsd: LDFLAGS += -L/usr/local/lib -pthread
openbsd: LIBS=-lzmq -lsqlite3 $(LDFLAGS)
openbsd: all

solaris: OPTFLAGS += -I/usr/local/include
solaris: LDFLAGS += -L/usr/local/lib -R/usr/local/lib -lsocket -lnsl -lsendfile
solaris: LDFLAGS += -L/lib -R/lib
solaris: all


macports: OPTFLAGS += -I/opt/local/include
macports: LDFLAGS += -L/opt/local/lib -undefined dynamic_lookup
macports: all

brew: OPTFLAGS += -I/usr/local/include
brew: LDFLAGS += -L/usr/local/lib -undefined dynamic_lookup
brew: all

=== debian/changelog ===
mongrel2 (1.12.0-1build1) disco; urgency=medium

  * No-change rebuild against libmbedtls12

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 12 Nov 2018 20:16:19 +0000

mongrel2 (1.12.0-1) unstable; urgency=medium

  * Update to upstream release 1.12.0

 -- Jan Niehusmann <jan@debian.org>  Fri, 06 Jul 2018 08:58:20 +0200

mongrel2 (1.11.0-8) unstable; urgency=medium

  * Point Vcs-* to salsa repository.
  * Fix lintian warning debian-rules-uses-unnecessary-dh-argument.
  * Fix lintian warning dep5-copyright-license-name-not-unique.

 -- Jan Niehusmann <jan@debian.org>  Fri, 11 May 2018 22:50:48 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper (>= 10.0.0), libzmq3-dev (>= 2.1), libsqlite3-dev (>= 3.0), sqlite3 (>= 3.0), libmbedtls-dev, dpkg-dev (>= 1.16.1~)
 Standards-Version: 3.9.8
 Homepage: http://mongrel2.org/
-Vcs-Git: git://anonscm.debian.org/users/jan/mongrel2.git
-Vcs-Browser: https://anonscm.debian.org/cgit/users/jan/mongrel2.git
+Vcs-Git: https://salsa.debian.org/jan/mongrel2.git
+Vcs-Browser: https://salsa.debian.org/jan/mongrel2
 
 Package: mongrel2-core
 Architecture: any
